/******************************************************************************/
/*
	dxdebug.h

	Desc: Some simple quick and dirty draw functions for testing and debug
	...slow but dirty!

*/
/******************************************************************************/

#pragma once


#pragma comment(lib, "D3d9.lib")
#pragma comment(lib, "D3dx9.lib")
#include <d3dx9.h>


#define DBG_HALT __asm{ int 0x10 }

#define DBG_ASSERT(exp) {if ( !(exp) ) {DBG_HALT;}}

/******************************************************************************/


//Saving debug information to a log file
__forceinline void dprintf(const char *fmt, ...) 
{
	/*
	va_list parms;
	char buf[256];

	// Try to print in the allocated space.
	va_start(parms, fmt);
	vsprintf (buf, fmt, parms);
	va_end(parms);

	// Write the information out to a txt file
	FILE *fp = fopen("output.txt", "a+");
	fprintf(fp, "%s",  buf);
	fclose(fp);
	*/
}// End dprintf(..)


/******************************************************************************/

/*
inline void DebugDrawBox2D(IDirect3DDevice9* pD3DDevice, float x0, float y0, float x1, float y1)
{
	struct TLVERTEX
	{
		float x,y,z,rhw;
		float tu,tv;
		enum { FVF_TLVERTEX = D3DFVF_XYZRHW | D3DFVF_TEX1 };
	};

	pD3DDevice->SetTextureStageState(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
	pD3DDevice->SetTextureStageState(0,D3DTSS_COLORARG1,	D3DTA_TEXTURE);
	float scale = 128.0f;
	TLVERTEX Vertex[4] = 
	{
		// x		y   z rhw tu tv
		{    0,    0,	0, 1, 0, 0,},
		{scale,    0,	0, 1, 1, 0,},
		{scale,scale,	0, 1, 1, 1,},
		{    0,scale,	0, 1, 0, 1,},
	};
	pD3DDevice->SetTexture( 0, NULL );
	pD3DDevice->SetVertexShader( TLVERTEX::FVF_TLVERTEX );
	pD3DDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, Vertex, sizeof( TLVERTEX ) );
}
*/


/******************************************************************************/


inline void DebugWireDrawBox2D(IDirect3DDevice9* pD3DDevice, float x0, float y0, float w0, float h0, DWORD col=0xff00ffff)
{
	struct VERTEX
	{
		float x,y,z,rhw;
		unsigned int rgba;
		enum { FVF_VERTEX = D3DFVF_XYZRHW | D3DFVF_DIFFUSE };
	};

	w0 = w0*0.5f;
	h0 = h0*0.5f;

	pD3DDevice->SetTextureStageState(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
	pD3DDevice->SetTextureStageState(0,D3DTSS_COLORARG1,	D3DTA_DIFFUSE);
	VERTEX Vertex[5] = 
	{
		// x   y		z  rhw, colour
		{ x0-w0,	y0-h0,	0, 1,  col},
		{ x0+w0,    y0-h0,	0, 1,  col},
		{ x0+w0,    y0+h0,	0, 1,  col},
		{ x0-w0,	y0+h0,	0, 1,  col},
		{ x0-w0,	y0-h0,	0, 1,  col},
	};
	pD3DDevice->SetTexture( 0, NULL );
	//pD3DDevice->SetVertexShader( VERTEX::FVF_VERTEX );
	pD3DDevice->SetFVF(VERTEX::FVF_VERTEX);
	pD3DDevice->DrawPrimitiveUP( D3DPT_LINESTRIP, 4, Vertex, sizeof( VERTEX ) );
}


/******************************************************************************/


inline void DebugDrawTexList2D(IDirect3DDevice9* pD3DDevice, IDirect3DTexture9* pTex,  D3DXVECTOR2* pPoints, D3DXVECTOR2* pTexPoints, int NumPoints, int depth,
							   float mulr, float mulg, float mulb, float mula,
							   int   addr, int   addg, int   addb, int   adda)
{
	struct TVERTEX
	{
		float x,y,z,rhw;
		DWORD colmul;
		DWORD coladd;
		float tu,tv;
		enum { FVF_TVERTEX = D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_SPECULAR | D3DFVF_TEX1  };
	};


	// stage 1 coloring
	pD3DDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_MODULATE);
	pD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	pD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);

	pD3DDevice->SetTextureStageState(1, D3DTSS_COLOROP,  D3DTOP_ADD );
	pD3DDevice->SetTextureStageState(1, D3DTSS_COLORARG1,D3DTA_SPECULAR );
	pD3DDevice->SetTextureStageState(1, D3DTSS_COLORARG2,D3DTA_CURRENT );


	// 0
	pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,  D3DTOP_MODULATE );
	pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1,D3DTA_TEXTURE );
	pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG2,D3DTA_DIFFUSE );

	// 1
	pD3DDevice->SetTextureStageState(1, D3DTSS_ALPHAOP,  D3DTOP_ADD);
	pD3DDevice->SetTextureStageState(1, D3DTSS_ALPHAARG1,D3DTA_CURRENT );
	pD3DDevice->SetTextureStageState(1, D3DTSS_ALPHAARG2,D3DTA_SPECULAR);

	pD3DDevice->SetTextureStageState(2, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );

	//             0xaarrggbb
	DWORD colmul = 0xff000000;
	DWORD coladd = 0xffff0000;
	

	float scale = 255;
	if (pTex)
		colmul = D3DCOLOR_ARGB((int)(mula*scale),(int)(mulr*scale),(int)(mulg*scale),(int)(mulb*scale));

	coladd = D3DCOLOR_ARGB(adda,addr,addg,addb);

	TVERTEX* Vertex = new TVERTEX[NumPoints];

	for (int i=0; i<NumPoints; i++)
	{
		Vertex[i].x=pPoints[i].x;
		Vertex[i].y=pPoints[i].y;
		Vertex[i].z=0;
		Vertex[i].rhw=1;
		Vertex[i].tu=pTexPoints[i].x;
		Vertex[i].tv=pTexPoints[i].y;

		Vertex[i].colmul = colmul;
		Vertex[i].coladd = coladd;

	}

	pD3DDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);

	pD3DDevice->SetTexture( 0, pTex );
	//pD3DDevice->SetVertexShader( TVERTEX::FVF_TVERTEX );
	pD3DDevice->SetFVF( TVERTEX::FVF_TVERTEX );
	pD3DDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, NumPoints-1, Vertex, sizeof( TVERTEX ) );
	
	delete[] Vertex;

	pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );
	pD3DDevice->SetTextureStageState(1, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );
	pD3DDevice->SetTextureStageState(2, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );
	pD3DDevice->SetTexture(0, NULL);
}


/******************************************************************************/


inline void DebugDrawLineList2D(IDirect3DDevice9* pD3DDevice, D3DXVECTOR2* pPoints, int NumPoints, DWORD col=0xff00ffff)
{
	struct VERTEX
	{
		float x,y,z,rhw;
		unsigned int rgba;
		enum { FVF_VERTEX = D3DFVF_XYZRHW | D3DFVF_DIFFUSE };
	};

	pD3DDevice->SetTextureStageState(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
	pD3DDevice->SetTextureStageState(0,D3DTSS_COLORARG1,	D3DTA_DIFFUSE);

	VERTEX* Vertex = new VERTEX[NumPoints + 5]; // safety buff
	for (int i=0; i<NumPoints; i++)
	{
		Vertex[i].x=pPoints[i].x;
		Vertex[i].y=pPoints[i].y;
		Vertex[i].z=0;
		Vertex[i].rhw=1;
		Vertex[i].rgba=col;
	}

	pD3DDevice->SetTexture( 0, NULL );
	//pD3DDevice->SetVertexShader( VERTEX::FVF_VERTEX );
	pD3DDevice->SetFVF( VERTEX::FVF_VERTEX );
	pD3DDevice->DrawPrimitiveUP( D3DPT_LINESTRIP, NumPoints-1, Vertex, sizeof( VERTEX ) );
	
	delete[] Vertex;
}


/******************************************************************************/

inline void DebugDrawLine2D(IDirect3DDevice9* pD3DDevice, D3DXVECTOR2& pf, D3DXVECTOR2& pt, DWORD col=0xff00ffff)
{
	D3DXVECTOR2 pts[] = { (pf),   (pt) };

	DebugDrawLineList2D(pD3DDevice, pts, 2, col);
}


inline void DebugDrawArrowLine2D(IDirect3DDevice9* pD3DDevice, D3DXVECTOR2& pf, D3DXVECTOR2& pt, DWORD col=0xff00ffff, float scale=1.0f)
{
	D3DXVECTOR2 dir = (pf) - (pt);
	float s = D3DXVec2Length(&dir);
	D3DXVec2Normalize(&dir, &dir);
	D3DXVECTOR2 dir90, dirn90;

	D3DXMATRIX mat;
	D3DXMatrixRotationZ(&mat, 3.14f/4.0f);
	D3DXVec2TransformCoord(&dir90, &dir, &mat);
	
	D3DXMatrixRotationZ(&mat, -3.14f/4.0f);
	D3DXVec2TransformCoord(&dirn90, &dir, &mat);


	s *= 0.2f;
	s = min(10.0f, s);

	D3DXVECTOR2 head0 = (pt) + dir90*s;
	D3DXVECTOR2 head1 = (pt) + dirn90*s;


	D3DXVECTOR2 pts[] = { (pf),   (pt),
						  (pt),   head0,
						  (pt),   head1,
						  head1,   head0 };


	DebugDrawLineList2D(pD3DDevice, pts, 8, col);
}
/******************************************************************************/

inline void DebugDrawCircle2D(IDirect3DDevice9* pD3DDevice, D3DXVECTOR2& c, float r, DWORD col=0xff00ffff)
{
	int maxSteps = 30;
	float stepInc = (3.14f * 2.0f) / maxSteps;

	for (int i=0; i<maxSteps; i++)
	{
		D3DXVECTOR2 pnts[2];

		pnts[0].x = c.x + r * sinf(i*stepInc);
		pnts[0].y = c.y + r * cosf(i*stepInc);

		pnts[1].x = c.x + r * sinf(((i+1)%maxSteps)*stepInc);
		pnts[1].y = c.y + r * cosf(((i+1)%maxSteps)*stepInc);

		DebugDrawLineList2D(pD3DDevice, pnts, 2, col);
	}
}

/******************************************************************************/


inline void DebugDrawTri2D(IDirect3DDevice9* pD3DDevice,
						   D3DXVECTOR2* points,
						   DWORD col)
{
	struct TVERTEX
	{
		float x,y,z,rhw;
		DWORD col;
		enum { FVF_TVERTEX = D3DFVF_XYZRHW | D3DFVF_DIFFUSE };
	};


	// stage 1 coloring
	pD3DDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1);
	pD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_DIFFUSE );
	pD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);

	pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );



	TVERTEX* Vertex = new TVERTEX[3];

	for (int i=0; i<3; i++)
	{
		Vertex[i].x=points[i].x;
		Vertex[i].y=points[i].y;
		Vertex[i].z=0;
		Vertex[i].rhw=1;
		Vertex[i].col = col;

	}

	//pD3DDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	pD3DDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);

	pD3DDevice->SetTexture( 0, NULL );
	//pD3DDevice->SetVertexShader( TVERTEX::FVF_TVERTEX );
	pD3DDevice->SetFVF( TVERTEX::FVF_TVERTEX );
	pD3DDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 1, Vertex, sizeof( TVERTEX ) );

	delete[] Vertex;

}


/******************************************************************************/



