/******************************************************************************/
/*                                                                            */
/*  File: test.h                                                              */
/*  Author: bkenwright@xbdev.net                                              */
/*  URL: www.xbdev.net                                                        */
/*                                                                            */
/******************************************************************************/
/*



*/
/******************************************************************************/

#pragma once


#include <d3dx9.h>


#include "DelaunayTriangulation.h" // triangulate_polygon(..)


D3DXVECTOR2 g_off = D3DXVECTOR2(0,0);


void test(IDirect3DDevice9* pDevice)
{

	const static int MAX_TRIS = 5000;

	static int			numContours				= 0;
	static D3DXVECTOR2	verts[2000]				= { D3DXVECTOR2(0,0) };
	static int			numVertsPerContour[100] = { 0 };
	static int			triangleIndices[MAX_TRIS]	= { 0 };
	static int			numTris					= 0;


	int val = 10;
	switch (val)
	{
		case 0:
		{
			numContours = 1;
			numVertsPerContour[0] = 5;

			verts[0] = D3DXVECTOR2(10,  10);
			verts[1] = D3DXVECTOR2(10,  100);
			verts[2] = D3DXVECTOR2(80,  150);
			verts[3] = D3DXVECTOR2(100, 100);
			verts[4] = D3DXVECTOR2(100, 10);
		}
		break;

		case 1:
		{
			numContours = 2;

			numVertsPerContour[0] = 5;
			verts[0] = D3DXVECTOR2(10,  10);
			verts[1] = D3DXVECTOR2(10,  100);
			verts[2] = D3DXVECTOR2(80,  150);
			verts[3] = D3DXVECTOR2(100, 100);
			verts[4] = D3DXVECTOR2(100, 10);

			numVertsPerContour[1] = 3;
			verts[5] = D3DXVECTOR2(40,  40);
			verts[6] = D3DXVECTOR2(80,  80);
			verts[7] = D3DXVECTOR2(40,  80);

		}
		break;

		case 2:
		{
			numContours = 3;

			numVertsPerContour[0] = 5;
			verts[0] = D3DXVECTOR2(10,  10);
			verts[1] = D3DXVECTOR2(10,  100);
			verts[2] = D3DXVECTOR2(80,  150);
			verts[3] = D3DXVECTOR2(100, 100);
			verts[4] = D3DXVECTOR2(100, 10);

			numVertsPerContour[1] = 3;
			verts[5] = D3DXVECTOR2(40,  40);
			verts[6] = D3DXVECTOR2(80,  80);
			verts[7] = D3DXVECTOR2(40,  80);

			numVertsPerContour[2] = 3;
			verts[8]  = D3DXVECTOR2(140,  140);
			verts[9]  = D3DXVECTOR2(140,  180);
			verts[10] = D3DXVECTOR2(180,  180);

		}
		break;

		case 3:
		{
			numContours = 2;
			int enumVertsPerContour[] = { 90,24 };
			D3DXVECTOR2 everts[] = {	
				D3DXVECTOR2(246.226837f, 240.000000f),
				D3DXVECTOR2(224.759064f, 239.999985f),
				D3DXVECTOR2(203.291321f, 239.999985f),
				D3DXVECTOR2(181.823578f, 240.000000f),
				D3DXVECTOR2(154.603394f, 202.595856f),
				D3DXVECTOR2(127.383247f, 165.191742f),
				D3DXVECTOR2(100.163086f, 127.787628f),
				D3DXVECTOR2(94.489738f, 127.984253f),
				D3DXVECTOR2(89.567581f, 128.102234f),
				D3DXVECTOR2(85.396591f, 128.141571f),
				D3DXVECTOR2(83.815163f, 128.131729f),
				D3DXVECTOR2(82.154678f, 128.102249f),
				D3DXVECTOR2(80.415123f, 128.053085f),
				D3DXVECTOR2(78.616249f, 127.984253f),
				D3DXVECTOR2(76.777863f, 127.895782f),
				D3DXVECTOR2(74.899925f, 127.787628f),
				D3DXVECTOR2(74.899918f, 151.032440f),
				D3DXVECTOR2(74.899918f, 174.277283f),
				D3DXVECTOR2(74.899925f, 197.522095f),
				D3DXVECTOR2(75.453415f, 210.717773f),
				D3DXVECTOR2(77.113907f, 220.098328f),
				D3DXVECTOR2(79.881393f, 225.663696f),
				D3DXVECTOR2(85.139610f, 229.990158f),
				D3DXVECTOR2(91.900177f, 232.586060f),
				D3DXVECTOR2(100.163086f, 233.451355f),
				D3DXVECTOR2(103.306152f, 233.451340f),
				D3DXVECTOR2(106.449219f, 233.451355f),
				D3DXVECTOR2(109.592293f, 233.451355f),
				D3DXVECTOR2(109.592285f, 235.634216f),
				D3DXVECTOR2(109.592300f, 237.817108f),
				D3DXVECTOR2(109.592293f, 240.000000f),
				D3DXVECTOR2(75.137138f, 239.999985f),
				D3DXVECTOR2(40.681988f, 239.999985f),
				D3DXVECTOR2(6.226834f, 240.000000f),
				D3DXVECTOR2(6.226834f, 237.817093f),
				D3DXVECTOR2(6.226834f, 235.634232f),
				D3DXVECTOR2(6.226834f, 233.451355f),
				D3DXVECTOR2(9.251296f, 233.451340f),
				D3DXVECTOR2(12.275761f, 233.451355f),
				D3DXVECTOR2(15.300223f, 233.451355f),
				D3DXVECTOR2(24.531750f, 232.350067f),
				D3DXVECTOR2(31.826044f, 229.046234f),
				D3DXVECTOR2(37.183098f, 223.539825f),
				D3DXVECTOR2(39.258705f, 218.210403f),
				D3DXVECTOR2(40.504074f, 209.537842f),
				D3DXVECTOR2(40.919197f, 197.522095f),
				D3DXVECTOR2(40.919193f, 145.840683f),
				D3DXVECTOR2(40.919197f, 94.159302f),
				D3DXVECTOR2(40.919197f, 42.477905f),
				D3DXVECTOR2(40.365696f, 29.282209f),
				D3DXVECTOR2(38.705212f, 19.901678f),
				D3DXVECTOR2(35.937733f, 14.336304f),
				D3DXVECTOR2(30.560907f, 10.009825f),
				D3DXVECTOR2(23.681740f, 7.413940f),
				D3DXVECTOR2(15.300223f, 6.548645f),
				D3DXVECTOR2(12.275760f, 6.548645f),
				D3DXVECTOR2(9.251297f, 6.548645f),
				D3DXVECTOR2(6.226834f, 6.548645f),
				D3DXVECTOR2(6.226834f, 4.365763f),
				D3DXVECTOR2(6.226834f, 2.182881f),
				D3DXVECTOR2(6.226834f, 0.000000f),
				D3DXVECTOR2(35.522606f, 0.000000f),
				D3DXVECTOR2(64.818382f, 0.000000f),
				D3DXVECTOR2(94.114159f, 0.000000f),
				D3DXVECTOR2(117.489487f, 0.619469f),
				D3DXVECTOR2(136.377563f, 2.477875f),
				D3DXVECTOR2(150.778351f, 5.575218f),
				D3DXVECTOR2(162.322678f, 10.334311f),
				D3DXVECTOR2(172.641464f, 17.177971f),
				D3DXVECTOR2(181.734619f, 26.106194f),
				D3DXVECTOR2(188.801559f, 36.715832f),
				D3DXVECTOR2(193.041748f, 48.603745f),
				D3DXVECTOR2(194.455139f, 61.769928f),
				D3DXVECTOR2(192.844055f, 75.870201f),
				D3DXVECTOR2(188.010864f, 88.672562f),
				D3DXVECTOR2(179.955505f, 100.176987f),
				D3DXVECTOR2(168.519867f, 109.970490f),
				D3DXVECTOR2(153.545822f, 117.640106f),
				D3DXVECTOR2(135.033356f, 123.185822f),
				D3DXVECTOR2(151.638245f, 146.135666f),
				D3DXVECTOR2(168.243134f, 169.085541f),
				D3DXVECTOR2(184.848038f, 192.035400f),
				D3DXVECTOR2(195.700500f, 206.076691f),
				D3DXVECTOR2(205.485535f, 216.578171f),
				D3DXVECTOR2(214.203125f, 223.539825f),
				D3DXVECTOR2(223.217178f, 228.102249f),
				D3DXVECTOR2(233.891785f, 231.406113f),
				D3DXVECTOR2(246.226837f, 233.451355f),
				D3DXVECTOR2(246.226822f, 235.634216f),
				D3DXVECTOR2(246.226837f, 237.817108f),
				D3DXVECTOR2(74.899925f, 116.637146f),
				D3DXVECTOR2(77.054596f, 116.646980f),
				D3DXVECTOR2(79.011612f, 116.676483f),
				D3DXVECTOR2(80.770935f, 116.725662f),
				D3DXVECTOR2(82.332581f, 116.774826f),
				D3DXVECTOR2(83.696564f, 116.804337f),
				D3DXVECTOR2(84.862862f, 116.814178f),
				D3DXVECTOR2(105.984680f, 115.162247f),
				D3DXVECTOR2(123.330872f, 110.206497f),
				D3DXVECTOR2(136.901413f, 101.946915f),
				D3DXVECTOR2(146.637009f, 91.130768f),
				D3DXVECTOR2(152.478378f, 78.505402f),
				D3DXVECTOR2(154.425507f, 64.070770f),
				D3DXVECTOR2(152.853958f, 50.019653f),
				D3DXVECTOR2(148.139359f, 37.836773f),
				D3DXVECTOR2(140.281693f, 27.522125f),
				D3DXVECTOR2(129.834442f, 19.705009f),
				D3DXVECTOR2(117.351120f, 15.014746f),
				D3DXVECTOR2(102.831726f, 13.451324f),
				D3DXVECTOR2(95.142067f, 13.824974f),
				D3DXVECTOR2(85.831482f, 14.945927f),
				D3DXVECTOR2(74.899925f, 16.814178f),
				D3DXVECTOR2(74.899918f, 50.088497f),
				D3DXVECTOR2(74.899918f, 83.362823f),
			};

			/*
			int indx = 0;
			int offset = 0;
			for (int c=0; c<numContours; c++)
			{
				int numV = enumVertsPerContour[c];
				for (int i=0; i<numV; i++)
				{
					DBG_ASSERT(indx< (sizeof(verts)/sizeof(D3DXVECTOR2)));
					verts[indx] = everts[offset + (numV - i - 1)];
					indx++;
				}
				offset+=numV;
			}
			*/
			

			memcpy(verts, everts, (sizeof(verts)/sizeof(D3DXVECTOR2)));

			memcpy(numVertsPerContour, enumVertsPerContour, sizeof(enumVertsPerContour));
		}
		break;

		case 4:
		{
			numContours = 2;

			numVertsPerContour[0] = 5;
			verts[0] = D3DXVECTOR2(10,  10);
			verts[1] = D3DXVECTOR2(10,  100);
			verts[2] = D3DXVECTOR2(80,  150);
			verts[3] = D3DXVECTOR2(100, 100);
			verts[4] = D3DXVECTOR2(100, 10);

			numVertsPerContour[1] = 3;
			verts[5] = D3DXVECTOR2(40,  40);
			verts[6] = D3DXVECTOR2(80,  99);
			verts[7] = D3DXVECTOR2(40,  80);

		}
		break;

		case 5:
		{
			numContours = 1;
			int num = 0;
			
			verts[num] = D3DXVECTOR2(10,  10);			num++;
			verts[num] = D3DXVECTOR2(50,  20);			num++;
			verts[num] = D3DXVECTOR2(80,  20);			num++;
			verts[num] = D3DXVECTOR2(100, 30);			num++;
			verts[num] = D3DXVECTOR2(140,  0);			num++;
			verts[num] = D3DXVECTOR2(20, -10);			num++;
			verts[num] = D3DXVECTOR2(90, -30);			num++;
			verts[num] = D3DXVECTOR2(130,-40);			num++;
			verts[num] = D3DXVECTOR2(5,  -60);			num++;

			numVertsPerContour[0] = num;

		}
		break;

		case 6:
		{
			numContours = 1;
			int num = 0;
			
			verts[num] = D3DXVECTOR2(10,  10);			num++;
			//verts[num] = D3DXVECTOR2(50,  20);			num++;
			//verts[num] = D3DXVECTOR2(80,  20);			num++;
			verts[num] = D3DXVECTOR2(100, 30);			num++;
			verts[num] = D3DXVECTOR2(140,  0);			num++;
			verts[num] = D3DXVECTOR2(20, -10);			num++;
			verts[num] = D3DXVECTOR2(90, -30);			num++;
			verts[num] = D3DXVECTOR2(130,-40);			num++;
			verts[num] = D3DXVECTOR2(5,  -60);			num++;

			numVertsPerContour[0] = num;

		}
		break;

		case 7:
		{
			numContours = 1;
			int num = 0;
			
			verts[num] = D3DXVECTOR2(10,  10);			num++;
			verts[num] = D3DXVECTOR2(50,  20);			num++;
			verts[num] = D3DXVECTOR2(80,  20);			num++;
			verts[num] = D3DXVECTOR2(82,  12);			num++;
			verts[num] = D3DXVECTOR2(100, 30);			num++;
			verts[num] = D3DXVECTOR2(140,  0);			num++;
			verts[num] = D3DXVECTOR2(20, -10);			num++;
			verts[num] = D3DXVECTOR2(90, -30);			num++;
			verts[num] = D3DXVECTOR2(130,-40);			num++;
			verts[num] = D3DXVECTOR2(5,  -60);			num++;

			numVertsPerContour[0] = num;

		}
		break;

		case 10:
		{
			// Dynamically add points with the mouse cursor
		}
		break;


		default: DBG_HALT;
	}

	static float triLimit = -1.0f;
#if 0
	triLimit = 9.0f;
	if( GetKeyState(VK_RIGHT)	& 0x80 )	triLimit+=0.1f; // '>' key
	if( GetKeyState(VK_LEFT)	& 0x80 )	triLimit-=0.1f; // '<' key
	triLimit = (triLimit<1.0f) ? 1.0f : triLimit;
#endif

	if (numContours>0 && numVertsPerContour[0]>1)
	// *** Trianglulation Code is done here where we chop up
	// the contours and splines into shapes :)
	TriangulatePolygon(	numContours,
						numVertsPerContour,
						verts,
						MAX_TRIS,
						&numTris,
						triangleIndices);



	
	static float s = 1.0f;

	extern bool g_rightButtonDown; // main.cpp
	POINT pnt;
	GetCursorPos(&pnt);
	extern HWND	g_hWnd;
	::ScreenToClient(g_hWnd, &pnt);
	D3DXVECTOR2 cpos = D3DXVECTOR2((float)pnt.x, (float)pnt.y);
	static D3DXVECTOR2 oldPos = cpos;
	D3DXVECTOR2 delta = D3DXVECTOR2(0,0);
	if (g_rightButtonDown)
	{
		delta.x = oldPos.x - cpos.x;
		delta.y = oldPos.y - cpos.y;
	}
	else
	{
		oldPos = cpos;
	}
	g_off.x -= delta.x;
	g_off.y -= delta.y;

	oldPos = cpos;


	extern bool g_leftButtonDown; // main.cpp
	if (val==10)
	{
		extern float g_zoom;
		s = g_zoom;

		DebugDrawCircle2D(pDevice, cpos*s + g_off, 5.0f, 0xffff0000);

		if (numVertsPerContour[0]>0)
		{
			int numV = numVertsPerContour[0];

			DebugDrawLine2D(pDevice, verts[numV-1]*s + g_off, cpos*s + g_off, 0x33000077);
		}

		if (g_leftButtonDown)
		{
			//g_leftButtonDown = false;

			numContours = 1;

			int numV = numVertsPerContour[0];
			
			float len = 10000.0f;
			
			if (numV>1)
				D3DXVec2Length( &(verts[numV-1]- cpos) );

			if (len>0.001f)
			{
				verts[numV] = cpos;


				numVertsPerContour[0] = numV+1;
			}
		}
	}



#if 1
	for (int i=0; i<numTris; i++)
	{
		int* triIndices = &triangleIndices[i * 3];

		int indx0 = triIndices[0];
		int indx2 = triIndices[1];
		int indx1 = triIndices[2];

		D3DXVECTOR2 p0 = verts[indx0];
		D3DXVECTOR2 p1 = verts[indx1];
		D3DXVECTOR2 p2 = verts[indx2];

		extern float g_zoom;
		s = g_zoom;

		D3DXVECTOR2 pnts[] = {	g_off + p0*s, g_off + p1*s,
								g_off + p1*s, g_off + p2*s,
								g_off + p2*s, g_off + p0*s };

		#if 1
			DebugDrawLineList2D(pDevice, pnts, 6);
		#endif

		#if 1 // draw solid
			D3DXVECTOR2 triPnts[3] = {p0*s + g_off, 
									  p1*s + g_off, 
									  p2*s + g_off};
			DebugDrawTri2D(pDevice, triPnts, 0x55ff0000);
		#endif
	}
#endif


#if 1
	int start = 0;
	for (int i=0; i<numContours; i++)
	{
		int numPoints = numVertsPerContour[i];
		for (int k=0; k<numPoints; k++)
		{
			extern float g_zoom;
			float s = g_zoom;

			D3DXVECTOR2 from = verts[start + k]*s + g_off;
			D3DXVECTOR2 to   = verts[start + (k+1)%numPoints]*s + g_off;
			DebugDrawArrowLine2D(pDevice, from, to, 0xAAffee00);
		}
		start += numPoints;
	}
#endif

}






